
/* Written by Tomas Zalusky, Zdenek Pichlik, Martin Aliger */

#include<stdio.h>

#define MAXNODES 256
#define INFTY 65536
#define HA 64
#define MIN(a,b) ((a)<(b)?(a):(b))
enum {FR,OP,CL};
enum {PLUS,MINUS};

int graf[MAXNODES][MAXNODES];
int f[MAXNODES][MAXNODES];
int stav[MAXNODES];
int p[MAXNODES], ptype[MAXNODES];
int d[MAXNODES];
int N, nh, nr, h, h1, r, hr, j, n, maxflow, offset, hri, nv;

char is[1<<20], is1[64];

char jmena[MAXNODES][32];
int hth[26*HA], htr[26*HA];

int indexSlova(int *table, char *s)
  {char zac=s[0];
   int zacatek, i;
   if (zac>='a' && zac<='z') zac=zac-'a'+'A';
   zacatek=(zac-'A')*HA;
   for (i=zacatek; strcmp(jmena[table[i]],s)!=0; i=(i+1)%(26*HA));
   return table[i];
  }

void zapisSlovo(int *table, char *s, int index)
  {char zac=s[0];
   int zacatek, i;
   if (zac>='a' && zac<='z') zac=zac-'a'+'A';
   zacatek=(zac-'A')*HA;
   for (i=zacatek; table[i]!=-1; i=(i+1)%(26*HA));
   table[i]=index;
  }

void smazHt(int *table) {int i; for (i=0; i<26*HA; i++) table[i]=-1;}

int najdiCestu()
  {int u, v, i;
   for (i=0; i<n; i++) stav[i]=FR;
   p[0]=0; d[0]=INFTY; stav[0]=OP;
   do
     {for (u=0; u<n; u++) if (stav[u]==OP) break;
      stav[u]=CL;
      for (v=0; v<n; v++) if (graf[u][v])
        if (stav[v]==FR && f[u][v]<1)
          {stav[v]=OP;
           p[v]=u; ptype[v]=PLUS;
           d[v]=MIN(d[u],1-f[u][v]);
          }
      for (v=0; v<n; v++) if (graf[v][u])
        if (stav[v]==FR && f[v][u]>0 )
          {stav[v]=OP;
           p[v]=u; ptype[v]=MINUS;
           d[v]=MIN(d[u],f[v][u]);
          }
      for (i=0; i<n; i++) if (stav[i]==OP) break;
     } while (!(i==n || u==1+nh+nr));
   return u==1+nh+nr;
  }

void zvysTok()
  {int x=1+nh+nr, delta=d[x], u, v;  /*int h, r;*/
   maxflow+=delta;
/*printf("------------\n");*/
   do
     {v=x; u=p[v];
/*printf("%s -> %s\n",jmena[u],jmena[v]);*/
      if (ptype[v]==PLUS) f[u][v]+=delta; else f[u][v]-=delta;
      f[v][u]=f[u][v];
      x=u;
     } while (!(v==0));

/*      for (h=0; h<n; h++)
        {for (r=0; r<n; r++) printf(" %i",f[h][r]);
         printf("\n");
        }
*/
  }

int main()
  {
   gets(is1); sscanf(is1,"%i",&N);
   while (N--)
     {gets(is1);
      sscanf(is1,"%i %i %i",&nh,&nr,&nv);   /* pocet hercu a roli a vyrazenych */
      n=1+nh+nr+1;
      smazHt(hth); smazHt(htr);

      for (h=0; h<nh; h++)
        {graf[0][h+1]=1; f[0][h+1]=f[h+1][0]=0;
         gets(jmena[h+1]);
/*printf("j>> %s\n",jmena[h+1]);*/
         zapisSlovo(hth,jmena[h+1],h+1);
        }
/*printf("precteni herci\n");*/

      for (r=0; r<nr; r++)
        {graf[1+nh+r][1+nh+nr]=1; f[1+nh+r][1+nh+nr]=f[1+nh+nr][1+nh+r]=0;
         gets(jmena[1+nh+r]);
/*printf("r>> %s\n",jmena[1+nh+r]);*/
         zapisSlovo(htr,jmena[1+nh+r],1+nh+r);
        }
/*printf("precteny role\n");*/

      for (h1=0; h1<nh; h1++)
        {gets(is);
/*printf(">> %s\n",is);*/
         sscanf(is,"%s %i",is1,&hr);  /* jmeno herce a pocet roli, jez umi */
         h=indexSlova(hth,is1);
         for (offset=0; is[offset]!=' '; offset++); offset++;
         for (        ; is[offset]!=' '; offset++); offset++;
/*printf("%s %i %i %i\n",is1,hr,h,offset);*/
         for (hri=0; hri<hr; hri++)
           {sscanf(is+offset,"%s",is1);
            offset+=strlen(is1)+1;
            r=indexSlova(htr,is1);
/*printf("%s %i\n",is1,r);*/
            graf[h][r]=1; f[h][r]=f[r][h]=0;
           }
        }
/*printf("precteny vazby\n");*/

      for (h1=0; h1<nv; h1++)   /* vyhazet nemocne herce */
        {gets(is);
         h=indexSlova(hth,is); graf[0][h]=0;
         for (hri=1+nh; hri<1+nh+nr; hri++) graf[h][hri]=0;
        }

/*
      for (h=0; h<n; h++)
        {for (r=0; r<n; r++) printf(" %i ",graf[h][r]);
         printf("\n");
        }
*/

      if (nh-nv<nr) printf("Zatraceni demonstranti!\n");
      else
        {maxflow=0;
         while (najdiCestu()) zvysTok();
/*      printf("maxflow=%i\n",maxflow);*/
         if (maxflow==nr) printf("Premiera bude!\n");
         else             printf("Zatraceni demonstranti!\n");
        }


      for (h=1; h<1+nh; h++) {graf[0][h]=0; f[0][h]=f[h][0]=0;}
      for (r=1+nh; r<1+nh+nr; r++) {graf[r][1+nh+nr]=0; f[r][1+nh+nr]=f[1+nh+nr][r]=0;}
      for (h=1; h<1+nh; h++) for (r=1+nh; r<1+nh+nr; r++)
        {graf[h][r]=0; f[h][r]=f[r][h]=0;
        }

     }
   return 0;
  }
